package de.bsvrz.datex2.test.mockclasses;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Assert;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.AttributeGroupUsage;
import de.bsvrz.dav.daf.main.config.AttributeType;
import de.bsvrz.dav.daf.main.config.BackupProgressCallback;
import de.bsvrz.dav.daf.main.config.BackupResult;
import de.bsvrz.dav.daf.main.config.ConfigurationArea;
import de.bsvrz.dav.daf.main.config.ConfigurationAuthority;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.ConfigurationObjectType;
import de.bsvrz.dav.daf.main.config.ConfigurationTaskException;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.DynamicObject;
import de.bsvrz.dav.daf.main.config.ObjectSetType;
import de.bsvrz.dav.daf.main.config.ObjectTimeSpecification;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.dav.daf.main.config.management.UserAdministration;
import de.bsvrz.dav.daf.main.impl.config.request.RequestException;


public class MockDataModel implements DataModel {

  private Map<String, AttributeGroup> atg = new HashMap<>();
  
  private Map<String, SystemObjectType> types = new HashMap<>();
  private Map<SystemObjectType,Collection<SystemObject>> objSet = new HashMap<>();

  @Override
  public BackupResult backupConfigurationFiles(String arg0, BackupProgressCallback arg1) throws ConfigurationTaskException,
      RequestException {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public BackupResult backupConfigurationFiles(String arg0, ConfigurationAuthority arg1, BackupProgressCallback arg2)
      throws ConfigurationTaskException, RequestException {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @SuppressWarnings("rawtypes")
  @Override
  public ConfigurationObject createConfigurationObject(ConfigurationObjectType arg0, String arg1, String arg2, List arg3)
      throws ConfigurationChangeException {
    Assert.fail();
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public DynamicObject createDynamicObject(SystemObjectType arg0, String arg1, String arg2) throws ConfigurationChangeException {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public short getActiveVersion(ConfigurationArea arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return 0;
  }

  @Override
  public Aspect getAspect(String arg0) {
    return new MockAspect(arg0);
  }

  @Override
  public AttributeGroup getAttributeGroup(String arg0) {
    return atg.get(arg0);
  }
  
  public Map<String, AttributeGroup> getAttributeGroupMap() {
    return atg;
  }

  @Override
  public AttributeGroupUsage getAttributeGroupUsage(long arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public AttributeType getAttributeType(String arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public List<SystemObjectType> getBaseTypes() {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public ConfigurationArea getConfigurationArea(String arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public ConfigurationAuthority getConfigurationAuthority() {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public String getConfigurationAuthorityPid() {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public Data[] getConfigurationData(Collection<SystemObject> arg0, AttributeGroup arg1) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public Data[] getConfigurationData(SystemObject[] arg0, AttributeGroup arg1) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public Data[] getConfigurationData(Collection<SystemObject> arg0, AttributeGroup arg1, Aspect arg2) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public Data[] getConfigurationData(SystemObject[] arg0, AttributeGroup arg1, Aspect arg2) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public SystemObject getObject(String arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public SystemObject getObject(long arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public ObjectSetType getObjectSetType(String arg0) {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public Collection<SystemObject> getObjects(String typ, long arg1, long arg2) {
    Collection<SystemObject> res = new ArrayList<SystemObject>();

    for (SystemObjectType sox : objSet.keySet()) {
      if (sox.getPid().equals(typ)) {
        res.addAll(objSet.get(sox));
      }
    }

    return res;
  }

  @Override
  public Collection<SystemObject> getObjects(Collection<ConfigurationArea> arg0, Collection<SystemObjectType> arg1,
      ObjectTimeSpecification arg2) {
    Collection<SystemObject> res = new ArrayList<SystemObject>();
    for (SystemObjectType x : arg1) {
      for (SystemObject sox : objSet.keySet()) {
        if (sox.getPid().equals(x.getPid())) {
          res.addAll(objSet.get(sox));
        }
      }
    }
    return res;
  }
  
  public void addObjects(SystemObjectType x,Collection<SystemObject> c) {
    objSet.put(x,c);
  }

  public void addObject(SystemObjectType type,SystemObject obj) {
    Collection<SystemObject> objTypeList = objSet.get(type);
    if (objTypeList == null) {
      objTypeList = new ArrayList<>();
      objSet.put(type, objTypeList);
    }
    objTypeList.add(obj);
  }

  public SystemObjectType createType(String pid) {
    SystemObjectType newObj = new MockSystemObjectType(pid, pid);
    types.put(pid, newObj);
    return newObj;
  }

  @Override
  public SystemObjectType getType(String pid) {
    SystemObjectType objType = types.get(pid);
    if (objType == null) {
      objType = createType(pid);
    }
    return objType;
  }

  @Override
  public SystemObjectType getTypeTypeObject() {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

  @Override
  public UserAdministration getUserAdministration() {
    // TODO Auto-generated method stub
    Assert.fail();
    return null;
  }

}
