package de.bsvrz.datex2.test.mockclasses;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import de.bsvrz.dav.daf.main.ApplicationCloseActionHandler;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.ClientDavParameters;
import de.bsvrz.dav.daf.main.ClientReceiverInterface;
import de.bsvrz.dav.daf.main.ClientSenderInterface;
import de.bsvrz.dav.daf.main.CommunicationError;
import de.bsvrz.dav.daf.main.ConnectionException;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataNotSubscribedException;
import de.bsvrz.dav.daf.main.DavConnectionListener;
import de.bsvrz.dav.daf.main.HistorySpecification;
import de.bsvrz.dav.daf.main.InconsistentLoginException;
import de.bsvrz.dav.daf.main.MissingParameterException;
import de.bsvrz.dav.daf.main.OneSubscriptionPerSendData;
import de.bsvrz.dav.daf.main.ReceiveOptions;
import de.bsvrz.dav.daf.main.ReceiverRole;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.SendSubscriptionNotConfirmed;
import de.bsvrz.dav.daf.main.SenderRole;
import de.bsvrz.dav.daf.main.Transactions;
import de.bsvrz.dav.daf.main.archive.ArchiveRequestManager;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ClientApplication;
import de.bsvrz.dav.daf.main.config.ConfigurationAuthority;
import de.bsvrz.dav.daf.main.config.ConfigurationTaskException;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.DavApplication;
import de.bsvrz.dav.daf.main.config.DynamicObject;
import de.bsvrz.dav.daf.main.config.SystemObject;

public class MockDavConnection implements ClientDavInterface {
  private DataModel dataModel;
  
  private class ReceiverList {
    public ReceiverList(ClientReceiverInterface arg0, SystemObject arg1) {
      this.impl = arg0;
      this.objList.add(arg1);
    }
    public ReceiverList(ClientReceiverInterface arg0, SystemObject[] arg1) {
      this.impl = arg0;
      this.objList.addAll(Arrays.asList(arg1));
    }
    public ReceiverList(ClientReceiverInterface arg0, Collection<SystemObject> arg1) {
      this.impl = arg0;
      objList.addAll(arg1);
    }
    ClientReceiverInterface impl;
    List<SystemObject> objList = new ArrayList<>();
  };
  
  public List<ReceiverList> clientReceiverInterface = new ArrayList<>();

  public MockDavConnection(ClientDavParameters arg0, DataModel arg1) throws MissingParameterException {
    this.dataModel = arg1;
  }
  
  public Set<ClientReceiverInterface> getReceiver(SystemObject obj) {
    Set<ClientReceiverInterface> result = new HashSet<>();
    for (ReceiverList recvStruct : clientReceiverInterface) {
      if (recvStruct.objList.contains(obj)) {
        result.add(recvStruct.impl);
      }
    }
    return result;
  }

  @Override
  public void addConnectionListener(DavConnectionListener arg0) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public boolean checkLoggedUserNameAndPassword(String arg0, String arg1) {
    // TODO Auto-generated method stub
    return false;
  }

  @Override
  public void connect() throws CommunicationError, ConnectionException {
    // TODO Auto-generated method stub
    
  }

  @Override
  public Data createData(AttributeGroup arg0) {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public void disconnect(boolean arg0, String arg1) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void enableExplicitApplicationReadyMessage() {
    // TODO Auto-generated method stub
    
  }

  @Override
  public ArchiveRequestManager getArchive() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public ArchiveRequestManager getArchive(SystemObject arg0) {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public ResultData[] getCachedData(SystemObject[] arg0, DataDescription arg1, ReceiveOptions arg2, HistorySpecification arg3) {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public ClientDavParameters getClientDavParameters() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public ResultData getData(SystemObject arg0, DataDescription arg1, long arg2) {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public ResultData[] getData(SystemObject[] arg0, DataDescription arg1, long arg2) {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public DataModel getDataModel() {
    return dataModel;
  }

  @Override
  public DataModel getDataModel(SystemObject arg0) throws ConfigurationTaskException {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public DataModel getDataModel(String arg0) throws ConfigurationTaskException {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public DataModel getDataModel(long arg0) throws ConfigurationTaskException {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public long getDavRoundTripTime() {
    // TODO Auto-generated method stub
    return 0;
  }

  @Override
  public ClientApplication getLocalApplicationObject() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public ConfigurationAuthority getLocalConfigurationAuthority() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public DavApplication getLocalDav() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public DynamicObject getLocalUser() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public long getTime() {
    // TODO Auto-generated method stub
    return 0;
  }

  @Override
  public Transactions getTransactions() {
    // TODO Auto-generated method stub
    return null;
  }

  @Override
  public void login() throws InconsistentLoginException, CommunicationError {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void login(String arg0, String arg1) throws InconsistentLoginException, CommunicationError {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void removeConnectionListener(DavConnectionListener arg0) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void sendApplicationReadyMessage() {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void sendData(ResultData arg0) throws DataNotSubscribedException, SendSubscriptionNotConfirmed {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void sendData(ResultData[] arg0) throws DataNotSubscribedException, SendSubscriptionNotConfirmed {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void setCloseHandler(ApplicationCloseActionHandler arg0) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void sleep(long arg0) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void sleepUntil(long arg0) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void subscribeReceiver(ClientReceiverInterface arg0, SystemObject[] arg1, DataDescription arg2, ReceiveOptions arg3,
      ReceiverRole arg4) {
    clientReceiverInterface.add(new ReceiverList(arg0, arg1));
  }

  @Override
  public void subscribeReceiver(ClientReceiverInterface arg0, SystemObject arg1, DataDescription arg2, ReceiveOptions arg3,
      ReceiverRole arg4) {
    clientReceiverInterface.add(new ReceiverList(arg0, arg1));
  }

  @Override
  public void subscribeReceiver(ClientReceiverInterface arg0, Collection<SystemObject> arg1, DataDescription arg2,
      ReceiveOptions arg3, ReceiverRole arg4) {
    clientReceiverInterface.add(new ReceiverList(arg0, arg1));
  }

  @Override
  public void subscribeReceiver(ClientReceiverInterface arg0, SystemObject[] arg1, DataDescription arg2, ReceiveOptions arg3,
      ReceiverRole arg4, long arg5) {
    clientReceiverInterface.add(new ReceiverList(arg0, arg1));
  }

  @Override
  public void subscribeReceiver(ClientReceiverInterface arg0, SystemObject arg1, DataDescription arg2, ReceiveOptions arg3,
      ReceiverRole arg4, long arg5) {
    clientReceiverInterface.add(new ReceiverList(arg0, arg1));
  }

  @Override
  public void subscribeReceiver(ClientReceiverInterface arg0, Collection<SystemObject> arg1, DataDescription arg2,
      ReceiveOptions arg3, ReceiverRole arg4, long arg5) {
    clientReceiverInterface.add(new ReceiverList(arg0, arg1));
  }

  @Override
  public void subscribeSender(ClientSenderInterface arg0, Collection<SystemObject> arg1, DataDescription arg2, SenderRole arg3)
      throws OneSubscriptionPerSendData {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void subscribeSender(ClientSenderInterface arg0, SystemObject[] arg1, DataDescription arg2, SenderRole arg3)
      throws OneSubscriptionPerSendData {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void subscribeSender(ClientSenderInterface arg0, SystemObject arg1, DataDescription arg2, SenderRole arg3)
      throws OneSubscriptionPerSendData {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void subscribeSource(ClientSenderInterface arg0, ResultData arg1) throws OneSubscriptionPerSendData {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void unsubscribeReceiver(ClientReceiverInterface arg0, SystemObject[] arg1, DataDescription arg2) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void unsubscribeReceiver(ClientReceiverInterface arg0, Collection<SystemObject> arg1, DataDescription arg2) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void unsubscribeReceiver(ClientReceiverInterface arg0, SystemObject arg1, DataDescription arg2) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void unsubscribeSender(ClientSenderInterface arg0, Collection<SystemObject> arg1, DataDescription arg2) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void unsubscribeSender(ClientSenderInterface arg0, SystemObject[] arg1, DataDescription arg2) {
    // TODO Auto-generated method stub
    
  }

  @Override
  public void unsubscribeSender(ClientSenderInterface arg0, SystemObject arg1, DataDescription arg2) {
    // TODO Auto-generated method stub
    
  }

  public void setDataModel(MockDataModel dataModel2) {
    this.dataModel = dataModel2;
  }

}
